=== modified file 'src/com/goldencode/p2j/oo/net/MediaLinkEntity.java'
--- src/com/goldencode/p2j/oo/net/MediaLinkEntity.java	2021-02-21 16:25:50 +0000
+++ src/com/goldencode/p2j/oo/net/MediaLinkEntity.java	2021-10-13 13:43:50 +0000
@@ -10,6 +10,7 @@
 ** 
 ** 003 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
 **                  signature.
+**     ME  20210929 Fix return object on deserialize, use enum literals in substitute.
 */
 
 /*
@@ -287,6 +288,7 @@
    {
       longchar pcMle = TypeFactory.initInput(_pcMle);
       object<? extends com.goldencode.p2j.oo.core.SerializationFormatEnum> poSerializedAs = TypeFactory.initInput(_poSerializedAs);
+      object<MediaLinkEntity> mle = TypeFactory.object(MediaLinkEntity.class);
       
       return function(MediaLinkEntity.class, "Deserialize", object.class, new Block((Body) () -> 
       {
@@ -298,11 +300,11 @@
          {
             undoThrow(AppError.newInstance(
                      TextOps.substitute("Unsupported MLE serialization type &1",
-                              poSerializedAs),
+                              poSerializedAs.ref().toLegacyString()),
                      new integer(0)));
          }
          
-         object<MediaLinkEntity> mle = ObjectOps.newInstance(MediaLinkEntity.class);
+         mle.assign(ObjectOps.newInstance(MediaLinkEntity.class));
          
          object<ObjectModelParser> parser = ObjectOps.newInstance(ObjectModelParser.class);
          object<JsonObject> jsonObj = ObjectOps.cast(parser.ref().parse(pcMle), JsonObject.class);
@@ -356,7 +358,7 @@
                   {
                      undoThrow(AppError.newInstance(
                               TextOps.substitute("Unsupported MLE serialization type &1",
-                                       poSerializedAs),
+                                       poSerializedAs.ref().toLegacyString()),
                               new integer(0)));
                   }
 

=== modified file 'src/com/goldencode/p2j/oo/net/MessagePart.java'
--- src/com/goldencode/p2j/oo/net/MessagePart.java	2022-01-20 16:27:48 +0000
+++ src/com/goldencode/p2j/oo/net/MessagePart.java	2022-02-11 15:26:27 +0000
@@ -12,6 +12,7 @@
 **         20201125 Set header value 'fluent', use substitute for toString. 
 ** 005 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy signature.
 **     OM  20210917 Code maintenance.
+**     ME  20210929 Add body to string representation (if valid).
 **     CA  20220120 Do not used TypeFactory.object when the OO reference must not be tracked or registered.
 **                  Do not use TypeFactory.object for internal usages, use ObjectVar if the reference must 
 **                  be tracked.
@@ -379,7 +380,7 @@
    {
       return function(this, "ToString", character.class, new Block((Body) () ->
       {
-         returnNormal(TextOps.substitute("&1_&2", getContentType(), handle.resourceId(ObjectOps.asResource(this))));
+         returnNormal(TextOps.substitute("&1_&2", getContentType(), body._isValid() ? body.ref().toLegacyString() : handle.resourceId(ObjectOps.asResource(this))));
       }
       ));
    }

=== modified file 'src/com/goldencode/p2j/oo/net/MultipartEntity.java'
--- src/com/goldencode/p2j/oo/net/MultipartEntity.java	2022-01-20 16:27:48 +0000
+++ src/com/goldencode/p2j/oo/net/MultipartEntity.java	2022-02-11 15:26:27 +0000
@@ -12,6 +12,7 @@
 **         20201123 Assert positive index on remove (OE 12.2).
 ** 005 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy signature.
 ** 006 ME  20210303 Increment/decrement object references for entity parts.
+**     ME  20210929 Fix return object on getPart.
 **     CA  20220120 Do not used TypeFactory.object when the OO reference must not be tracked or registered.
 **                  Do not use TypeFactory.object for internal usages, use ObjectVar if the reference must 
 **                  be tracked.
@@ -365,13 +366,17 @@
    public object<? extends MessagePart> getPart(final integer _n)
    {
       integer n = TypeFactory.initInput(_n);
+      object<? extends MessagePart> part = TypeFactory.object(MessagePart.class);
       
       return function(this, "GetPart", object.class, new Block((Body) () -> {
          Assert.isPositive(n, new character("Part num"));
          
-         Optional<OrderedPart> part = parts.stream().filter(p -> p.num == n.intValue()).findFirst();
-         
-         returnNormal(part.isPresent() ? part.get().entity : new object(MessagePart.class));
+         Optional<OrderedPart> opt = parts.stream().filter(p -> p.num == n.intValue()).findFirst();
+         
+         if (opt.isPresent())
+            part.assign(opt.get().entity);
+         
+         returnNormal(part);
       }));
    }
 

=== modified file 'src/com/goldencode/p2j/oo/net/Uri.java'
--- src/com/goldencode/p2j/oo/net/Uri.java	2022-01-20 16:27:48 +0000
+++ src/com/goldencode/p2j/oo/net/Uri.java	2022-02-11 15:26:27 +0000
@@ -19,6 +19,7 @@
 **     OM  20210323 Reworked I18n in LOB implementation.
 **     VVT 20210917 Javadoc fixed.
 **     OM  20210917 Code maintenance.
+**     ME  20210929 Fix return object on parse/resolveRelativeReference.
 **     CA  20220120 Do not used TypeFactory.object when the OO reference must not be tracked or registered.
 **                  Do not use TypeFactory.object for internal usages, use ObjectVar if the reference must 
 **                  be tracked.
@@ -209,31 +210,41 @@
    @LegacySignature(returns = "INTEGER", type = Type.GETTER, name = "SCHEME_PART_IDX")
    public static integer getSchemePartIdx()
    {
-      return schemePartIdx.get();
+      return function(Uri.class, "SCHEME_PART_IDX", integer.class, new Block((Body) () -> {
+         returnNormal(schemePartIdx.get());
+      }));
    }
 
    @LegacySignature(returns = "INTEGER", type = Type.GETTER, name = "AUTHORITY_PART_IDX")
    public static integer getAuthorityPartIdx()
    {
-      return authorityPartIdx.get();
+      return function(Uri.class, "AUTHORITY_PART_IDX", integer.class, new Block((Body) () -> {
+         returnNormal(authorityPartIdx.get());
+      }));
    }
 
    @LegacySignature(returns = "INTEGER", type = Type.GETTER, name = "PATH_PART_IDX")
    public static integer getPathPartIdx()
    {
-      return pathPartIdx.get();
+      return function(Uri.class, "PATH_PART_IDX", integer.class, new Block((Body) () -> {
+         returnNormal(pathPartIdx.get());
+      }));
    }
 
    @LegacySignature(returns = "INTEGER", type = Type.GETTER, name = "QUERY_PART_IDX")
    public static integer getQueryPartIdx()
    {
-      return queryPartIdx.get();
+      return function(Uri.class, "QUERY_PART_IDX", integer.class, new Block((Body) () -> {
+         returnNormal(queryPartIdx.get());
+      }));
    }
 
    @LegacySignature(returns = "INTEGER", type = Type.GETTER, name = "FRAGMENT_PART_IDX")
    public static integer getFragmentPartIdx()
    {
-      return fragmentPartIdx.get();
+      return function(Uri.class, "FRAGMENT_PART_IDX", integer.class, new Block((Body) () -> {
+         returnNormal(fragmentPartIdx.get());
+      }));
    }
 
    private static void _appendEscape(StringBuffer sb, byte b)
@@ -365,7 +376,9 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_STUB)
    public character getBaseUri()
    {
-      return new character(_getBaseUri());
+      return function(this, "BaseURI", character.class, new Block((Body) () -> {
+         returnNormal(new character(_getBaseUri()));
+      }));
    }
 
    public String _getBaseUri()
@@ -382,22 +395,32 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
    public character getFragment()
    {
-      return fragment;
+      return function(this, "Fragment", character.class, new Block((Body) () -> {
+         returnNormal(fragment);
+      }));
+      
    }
 
    @LegacySignature(type = Type.SETTER, name = "Fragment", parameters = {
-            @LegacyParameter(name = "var", type = "CHARACTER", mode = "INPUT") })
-   @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
-   public void setFragment(final character var)
+            @LegacyParameter(name = "_var", type = "CHARACTER", mode = "INPUT") })
+   @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | CVT_LVL_FULL)
+   public void setFragment(final character _var)
    {
-      fragment.assign(var.isUnknown() ? "" : var);
+      character var = TypeFactory.initInput(_var);
+      
+      internalProcedure(Uri.class, this, "Fragment", new Block((Body) () -> 
+      {
+         fragment.assign(var.isUnknown() ? "" : var);
+      }));
    }
 
    @LegacySignature(returns = "CHARACTER", type = Type.GETTER, name = "Host")
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_STUB)
    public character getHost()
    {
-      return host;
+      return function(this, "Host", character.class, new Block((Body) () -> {
+         returnNormal(host);
+      }));
    }
 
    protected String _getAuthority() {
@@ -451,96 +474,128 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
    public character getPassword()
    {
-      return password;
+      return function(this, "Password", character.class, new Block((Body) () -> {
+         returnNormal(password);
+      }));
    }
 
    @LegacySignature(type = Type.SETTER, name = "Password", parameters = {
-            @LegacyParameter(name = "var", type = "CHARACTER", mode = "INPUT") })
-   @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
-   public void setPassword(final character var)
+            @LegacyParameter(name = "_var", type = "CHARACTER", mode = "INPUT") })
+   @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | CVT_LVL_FULL)
+   public void setPassword(final character _var)
    {
-      password.assign(var);
+      character var = TypeFactory.initInput(_var);
+      
+      internalProcedure(Uri.class, this, "Password", new Block((Body) () -> 
+      {
+         password.assign(var);
+      }));
    }
 
    @LegacySignature(returns = "CHARACTER", type = Type.GETTER, name = "Path")
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_STUB)
    public character getPath()
    {
-      return path;
+      return function(this, "Path", character.class, new Block((Body) () -> {
+         returnNormal(path);
+      }));
    }
 
    @LegacySignature(type = Type.SETTER, name = "Path", parameters = {
-            @LegacyParameter(name = "pPath", type = "CHARACTER", mode = "INPUT") })
+            @LegacyParameter(name = "_pPath", type = "CHARACTER", mode = "INPUT") })
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
-   public void setPath(final character pPath)
+   public void setPath(final character _pPath)
    {
-      Assert.notNullOrEmpty(pPath, new character("path"));
-      
-      // no validation nor encoding, this is probably a bug and should just call protected setPath method instead
-      String newPath = pPath.getValue();
-      
-      if (!newPath.startsWith("/"))
-         newPath = "/" + newPath;
-      
-      path.assign(newPath);
+      character pPath = TypeFactory.initInput(_pPath);
+      
+      internalProcedure(Uri.class, this, "Path", new Block((Body) () -> 
+      {
+         Assert.notNullOrEmpty(pPath, new character("path"));
+         
+         // no validation nor encoding, this is probably a bug and should just call protected setPath method instead
+         String newPath = pPath.getValue();
+         
+         if (!newPath.startsWith("/"))
+            newPath = "/" + newPath;
+         
+         path.assign(newPath);
+      }));
    }
 
    @LegacySignature(type = Type.METHOD, name = "SetPath", parameters = {
-            @LegacyParameter(name = "pPath", type = "CHARACTER", mode = "INPUT") })
+            @LegacyParameter(name = "_pPath", type = "CHARACTER", mode = "INPUT") })
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
-   protected void setPath_1(final character pPath)
+   protected void setPath_1(final character _pPath)
    {
-      String newPath = pPath.isUnknown() ? "/" : pPath.getValue();
-      
-      if (!newPath.startsWith("/"))
-         newPath = "/" + newPath;
-      
-      if (newPath.length() > 1) {
-         String[] entries = TextOps.entries(newPath, "/");
-         
-         newPath = Arrays.stream(entries).map(p -> _encodeString(p, null, pathAllowed, false)).collect(Collectors.joining("/"));
-      }
-      
-      path.assign(newPath);
+      character pPath = TypeFactory.initInput(_pPath);
+      
+      internalProcedure(Uri.class, this, "SetPath", new Block((Body) () -> 
+      {
+         String newPath = pPath.isUnknown() ? "/" : pPath.getValue();
+         
+         if (!newPath.startsWith("/"))
+            newPath = "/" + newPath;
+         
+         if (newPath.length() > 1) {
+            String[] entries = TextOps.entries(newPath, "/");
+            
+            newPath = Arrays.stream(entries).map(p -> _encodeString(p, null, pathAllowed, false)).collect(Collectors.joining("/"));
+         }
+         
+         setPath(new character(newPath));
+      }));
    }
 
    @LegacySignature(returns = "INTEGER", type = Type.GETTER, name = "Port")
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
    public integer getPort()
    {
-      return port;
+      return function(this, "Port", integer.class, new Block((Body) () -> {
+         returnNormal(port);
+      }));
    }
 
    @LegacySignature(type = Type.SETTER, name = "Port", parameters = {
-            @LegacyParameter(name = "var", type = "INTEGER", mode = "INPUT") })
+            @LegacyParameter(name = "_var", type = "INTEGER", mode = "INPUT") })
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
-   public void setPort(final integer var)
+   public void setPort(final integer _var)
    {
-      port.assign(var);
+      integer var = TypeFactory.initInput(_var);
+      
+      internalProcedure(Uri.class, this, "Port", new Block((Body) () -> 
+      {
+         port.assign(var);
+      }));
    }
 
    @LegacySignature(returns = "OBJECT", qualified = "OpenEdge.Core.Collections.IStringStringMap", type = Type.GETTER, name = "QueryMap")
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
    protected object<? extends com.goldencode.p2j.oo.core.collections.IStringStringMap> getQueryMap()
    {
-      if (queryMap.isUnknown())
-         queryMap.assign(ObjectOps.newInstance(StringStringMap.class));
+      return function(this, "QueryMap", object.class, new Block((Body) () -> {
+         if (queryMap.isUnknown())
+            queryMap.assign(ObjectOps.newInstance(StringStringMap.class));
 
-      return queryMap;
+         returnNormal(queryMap);
+      }));
    }
 
    @LegacySignature(returns = "OBJECT", type = Type.METHOD, name = "GetQueryMap", qualified = "openedge.core.collections.istringstringmap")
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
    public object<? extends com.goldencode.p2j.oo.core.collections.IStringStringMap> getQueryMap_1()
    {
-      return ObjectOps.newInstance(StringStringMap.class, "I", getQueryMap());
+      return function(this, "GetQueryMap", object.class, new Block((Body) () -> {
+         returnNormal(ObjectOps.newInstance(StringStringMap.class, "I", getQueryMap()));
+      }));
    }
 
    @LegacySignature(returns = "CHARACTER", type = Type.GETTER, name = "QueryString")
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_STUB)
    public character getQueryString()
    {
-      return new character(_getQueryString(false));
+      return function(this, "QueryString", character.class, new Block((Body) () -> {
+         returnNormal(new character(_getQueryString(false)));
+      }));
    }
 
    private void _setQueryString(final character var)
@@ -583,7 +638,9 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_STUB)
    public character getRelativeUri()
    {
-      return new character(_getRelativeUri());
+      return function(this, "RelativeURI", character.class, new Block((Body) () -> {
+         returnNormal(new character(_getRelativeUri()));
+      }));
    }
 
    public String _getRelativeUri()
@@ -605,21 +662,30 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_STUB)
    public character getScheme()
    {
-      return scheme;
+      return function(this, "Scheme", character.class, new Block((Body) () -> {
+         returnNormal(scheme);
+      }));
    }
 
    @LegacySignature(returns = "CHARACTER", type = Type.GETTER, name = "User")
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_STUB)
    public character getUser()
    {
-      return user;
+      return function(this, "User", character.class, new Block((Body) () -> {
+         returnNormal(user);
+      }));
    }
 
    @LegacySignature(type = Type.SETTER, name = "User", parameters = {
-            @LegacyParameter(name = "var", type = "CHARACTER", mode = "INPUT") })
-   public void setUser(final character var)
+            @LegacyParameter(name = "_var", type = "CHARACTER", mode = "INPUT") })
+   public void setUser(final character _var)
    {
-      user.assign(var);
+      character var = TypeFactory.initInput(_var);
+      
+      internalProcedure(Uri.class, this, "User", new Block((Body) () -> 
+      {
+         user.assign(var);
+      }));
    }
 
    @LegacySignature(type = Type.CONSTRUCTOR)
@@ -708,41 +774,45 @@
    public void __net_Uri_constructor__(final character pScheme, final character pAuthority,
             final character pPath, final character pQuery, final character pFragment)
    {
-      __lang_BaseObject_constructor__();
-      Assert.notNullOrEmpty(pScheme, new character("Scheme"));
-      scheme.assign(pScheme);
-
-      setAuthority(pAuthority, new logical(true));
-
-      if (pPath.isUnknown() || pPath.getValue().trim().isEmpty())
-      {
-         path.assign("/");
-      }
-      else
-      {
-         setPath(encodeFragment(pPath));
-      }
-
-      _setQueryString(pQuery);
-      setFragment(pFragment);
+      character scheme = TypeFactory.initInput(pScheme);
+      character authority = TypeFactory.initInput(pAuthority);
+      character path = TypeFactory.initInput(pPath);
+      character fragment = TypeFactory.initInput(pFragment);
+      character query = TypeFactory.initInput(pQuery);
+      
+      internalProcedure(this, "__net_Uri_constructor__", new Block((Body) () -> {
+         __lang_BaseObject_constructor__();
+         Assert.notNullOrEmpty(scheme, new character("URI Scheme"));
+         this.scheme.assign(scheme);
+   
+         setAuthority(authority, new logical(true));
+   
+         setPath_1(path);
+   
+         addQueryString(query, new logical(true));
+         setFragment(fragment);
+      }));
    }
 
    @LegacySignature(type = Type.METHOD, name = "AddPathSegment", parameters = {
-            @LegacyParameter(name = "p1", type = "CHARACTER", mode = "INPUT") })
-   @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
-   public void addPathSegment(final character p1)
+            @LegacyParameter(name = "_p1", type = "CHARACTER", mode = "INPUT") })
+   @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | CVT_LVL_FULL)
+   public void addPathSegment(final character _p1)
    {
-
-      character seg = encodePath(p1);
-
-      if (!seg.getValue().trim().isEmpty())
-      {
-         if (this.path.getValue().endsWith("/"))
-            this.path.assign(this.path.getValue() + seg.getValue());
-         else
-            this.path.assign(this.path.getValue() + "/" + seg.getValue());
-
-      }
+      character p1 = TypeFactory.initInput(_p1);
+      
+      internalProcedure(this, "AddPathSegment", new Block((Body) () -> {
+         character seg = encodePath(p1);
+   
+         if (!seg.getValue().trim().isEmpty())
+         {
+            if (this.path.getValue().endsWith("/"))
+               this.path.assign(this.path.getValue() + seg.getValue());
+            else
+               this.path.assign(this.path.getValue() + "/" + seg.getValue());
+   
+         }
+      }));
    }
 
    @LegacySignature(type = Type.METHOD, name = "AddQuery", parameters = {
@@ -1428,7 +1498,6 @@
 
       character p1 = TypeFactory.initInput(_p1);
       logical p2 = TypeFactory.initInput(_p2);
-
       object<Uri> obj = TypeFactory.object(Uri.class);
 
       return function(Uri.class, "Parse", object.class, new Block((Body) () -> {

=== modified file 'src/com/goldencode/p2j/oo/net/http/ClientBuilder.java'
--- src/com/goldencode/p2j/oo/net/http/ClientBuilder.java	2021-05-24 06:41:34 +0000
+++ src/com/goldencode/p2j/oo/net/http/ClientBuilder.java	2021-10-13 13:43:50 +0000
@@ -12,6 +12,7 @@
 ** 005 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
 **                  signature.
 ** 006 ME  20210519 Fix registry lazy loading.
+**     ME  20210929 Fix return object on build.
 */
 
 /*
@@ -175,15 +176,15 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
    public static object<? extends com.goldencode.p2j.oo.net.http.ClientBuilder> build()
    {
-      return function(ClientBuilder.class, "Build", object.class, new Block((Body) () ->
-      {
+      object<? extends ClientBuilder> builder = TypeFactory.object(ClientBuilder.class);
+
+      return function(ClientBuilder.class, "Build", object.class, new Block((Body) () -> {
          object<? extends LegacyClass> builderType = getRegistry().ref()
                   .get(new character(ObjectOps.getLegacyName(ClientBuilder.class)));
-         
+
          Assert.isType(builderType, ObjectOps.getLegacyClass(ClientBuilder.class));
 
-         object<? extends _BaseObject_> builder = ObjectOps
-                  .newInstance(builderType.ref().getType());
+         builder.assign(ObjectOps.newInstance(builderType.ref().getType()));
 
          if (!builder.isUnknown() && builder.ref() instanceof ISupportInitialize)
             ((ISupportInitialize) builder.ref()).initialize();
@@ -248,7 +249,7 @@
             final object<? extends com.goldencode.p2j.oo.net.http.IhttpClient> p2)
    {
       object<? extends com.goldencode.p2j.oo.lang.LegacyClass> _p1 = TypeFactory.initInput(p1);
-      object<? extends _BaseObject_> client = TypeFactory.object(IhttpClient.class);
+      object<? extends IhttpClient> client = TypeFactory.object(IhttpClient.class);
       
       return function(ClientBuilder.class, "DecorateClient", object.class,  new Block((Body) () -> {
          
@@ -305,7 +306,7 @@
    {
       return function(null, "Registry", object.class, new Block((Body) () ->
       {
-         if (!registry.get().isValid().booleanValue()) {
+         if (!registry.get()._isValid()) {
             registry.get().assign(ObjectOps.newInstance(BuilderRegistry.class));
             initializeRegistry(registry.get());
          }

=== modified file 'src/com/goldencode/p2j/oo/net/http/Cookie.java'
--- src/com/goldencode/p2j/oo/net/http/Cookie.java	2021-09-17 15:14:10 +0000
+++ src/com/goldencode/p2j/oo/net/http/Cookie.java	2022-02-11 15:26:27 +0000
@@ -13,6 +13,7 @@
 ** 004 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
 **                  signature.
 **     VVT 20210917 Javadoc fixed. 
+**     ME  20210929 Fix return object on parse.
 */
 
 /*
@@ -416,7 +417,8 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
    public static object<? extends Cookie> parse(final character p1)
    {
-
+      object<? extends Cookie> returnedCookie = TypeFactory.object(Cookie.class);
+      
       return function(Cookie.class, "Parse", object.class, new Block((Body) () -> {
          Assert.notNullOrEmpty(p1, new character("Cookie"));
 
@@ -497,9 +499,9 @@
 
          }
 
-         object<? extends Cookie> returnedCookie = ObjectOps.newInstance(Cookie.class,
+        returnedCookie.assign(ObjectOps.newInstance(Cookie.class,
                   "IIIIIIIII", name, domain, path, value, maxAge, expires, secure, httpOnly,
-                  version);
+                  version));
 
          returnNormal(returnedCookie);
 

=== modified file 'src/com/goldencode/p2j/oo/net/http/CookieJar.java'
--- src/com/goldencode/p2j/oo/net/http/CookieJar.java	2021-06-09 14:35:48 +0000
+++ src/com/goldencode/p2j/oo/net/http/CookieJar.java	2021-10-13 13:43:50 +0000
@@ -14,6 +14,7 @@
 **                  signature.
 **     CA  20210609 Updated INPUT/INPUT-OUTPUT parameters to the new approach, where they are explicitly 
 **                  initialized at the method's execution, and not at the caller's arguments.
+**     ME  20211012 Increment/decrement object references on add/remove. 
 */
 
 /*
@@ -349,7 +350,7 @@
 
       internalProcedure(CookieJar.class, this, "AddCookie", new Block((Body) () -> {
          Assert.notNull(poCookie, new character("Cookie"));
-         addCookie(poCookie.ref().getDomain(), _poCookie.ref().getPath(), _poCookie);
+         addCookie(poCookie.ref().getDomain(), poCookie.ref().getPath(), poCookie);
       }));
    }
 
@@ -428,13 +429,15 @@
          // persistent first
          all.addAll(_getCookies(persistentCookies.get(), domain, path, http, secure));
          all.addAll(_getCookies(sessionCookies, domain, path, http, secure));
-         extpoCookies[0] = ArrayAssigner.resize(extpoCookies[0], all.size());
          
-         for (int i = 0; i < extpoCookies.length; i++)
-         {
-            extpoCookies[0][i] = all.get(i);
+         if (all.size() > 0) {
+            extpoCookies[0] = ArrayAssigner.resize(extpoCookies[0], all.size());
+            
+            for (int i = 0; i < all.size(); i++)
+            {
+               extpoCookies[0][i].assign(all.get(i));
+            }
          }
-
          returnNormal(new integer(extpoCookies[0].length));
       }));
    }
@@ -461,14 +464,19 @@
             List<CookieJarEntry> store)
    {
 
-      Optional<CookieJarEntry> entry = store.stream()
+      Optional<CookieJarEntry> first = store.stream()
                .filter(e -> e.domain.equalsIgnoreCase(cookie.getDomain().getValue())
                         && e.path.equalsIgnoreCase(cookie.getPath().getValue())
                         && e.name.equalsIgnoreCase(cookie.getName().getValue()))
                .findFirst();
 
-      if (entry.isPresent()) {
-         return store.remove(entry.get());
+      if (first.isPresent()) {
+         CookieJarEntry entry = first.get();
+         if (store.remove(entry)) {
+            if (entry.cookie._isValid())
+               ObjectOps.decrement(entry.cookie.ref());
+            return true;
+         }
       }
       
       return false;
@@ -476,21 +484,27 @@
 
    private void _addCookie(CookieJarEntry cookie, List<CookieJarEntry> store)
    {
-      Optional<CookieJarEntry> entry = store.stream()
+      Optional<CookieJarEntry> find = store.stream()
                .filter(e -> e.domain.equalsIgnoreCase(cookie.domain)
                         && e.path.equalsIgnoreCase(cookie.path)
                         && e.name.equalsIgnoreCase(cookie.name))
                .findFirst();
 
-      if (entry.isPresent())
+      if (find.isPresent())
       {
          // already have a cookie with same name for domain/path pair
-         entry.get().cookie.assign(cookie.cookie);
+         CookieJarEntry entry = find.get();
+         if (entry.cookie._isValid())
+            ObjectOps.decrement(entry.cookie.ref());
+         
+         entry.cookie.assign(cookie.cookie);
       }
       else
       {
          store.add(cookie);
       }
+      
+      ObjectOps.increment(cookie.cookie.ref());
    }
 
    private boolean _isExpired(Cookie cookie)

=== modified file 'src/com/goldencode/p2j/oo/net/http/CookieJarBuilder.java'
--- src/com/goldencode/p2j/oo/net/http/CookieJarBuilder.java	2021-05-24 06:41:34 +0000
+++ src/com/goldencode/p2j/oo/net/http/CookieJarBuilder.java	2021-10-13 13:43:50 +0000
@@ -123,7 +123,7 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL|RT_LVL_FULL)
    public static object<? extends BuilderRegistry> getRegistry()
    {
-      return function(null, "Registry", object.class, new Block((Body) () -> 
+      return function(CookieJarBuilder.class, "Registry", object.class, new Block((Body) () -> 
       {
          if(!registry.get()._isValid())
          {

=== modified file 'src/com/goldencode/p2j/oo/net/http/DefaultCookieJarBuilder.java'
--- src/com/goldencode/p2j/oo/net/http/DefaultCookieJarBuilder.java	2021-02-21 16:25:50 +0000
+++ src/com/goldencode/p2j/oo/net/http/DefaultCookieJarBuilder.java	2021-10-13 13:43:50 +0000
@@ -10,6 +10,7 @@
 **          20201028 Fix ctor and jar supporting initialization.
 ** 003 CA   20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
 **                   signature.
+**     ME   20210929 Fix return object on getCookieJar.
 */
 
 /*
@@ -127,6 +128,8 @@
    @Override
    public object<? extends ICookieJar> getCookieJar()
    {
+      object<? extends ICookieJar> cookieJar = TypeFactory.object(ICookieJar.class);
+      
       return function(this, "CookieJar", object.class, new Block((Body)() ->
       {
          object<? extends LegacyClass> cookieJarType = CookieJarBuilder.getRegistry().ref()
@@ -134,8 +137,7 @@
          
          Assert.isType(cookieJarType, ObjectOps.getLegacyClass(ICookieJar.class));
          
-         object<? extends ICookieJar> cookieJar = (object<? extends ICookieJar>) 
-                  ObjectOps.newInstance(cookieJarType.ref().getType());
+         cookieJar.assign(ObjectOps.newInstance(cookieJarType.ref().getType()));
          
          if (hasOption(new character(OPTION_PERSIST_TO)).booleanValue())
          {

=== modified file 'src/com/goldencode/p2j/oo/net/http/DefaultHeaderBuilder.java'
--- src/com/goldencode/p2j/oo/net/http/DefaultHeaderBuilder.java	2022-01-20 16:27:48 +0000
+++ src/com/goldencode/p2j/oo/net/http/DefaultHeaderBuilder.java	2022-02-11 15:26:27 +0000
@@ -9,6 +9,7 @@
 ** 002 ME   20200512 Add header parameters.
 **          20201204 Fix function block scope for error handling.
 ** 003 CA   20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy signature.
+**     ME   20210929 Fix return object on newHeader.
 **     CA  20220120 Do not used TypeFactory.object when the OO reference must not be tracked or registered.
 **                  Do not use TypeFactory.object for internal usages, use ObjectVar if the reference must 
 **                  be tracked.

